{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 2000 XP Team, weitere Informationen unter:                 }
{                   http://www.xp2.de                             }
{                                                                 }
{ Dieser Quelltext kann im Rahmen des XP-Projektes frei genutzt  }
{ werden                                                          }
{ --------------------------------------------------------------- }

unit xplinux;

{$I XPDEFINE.INC }

{$IFNDEF Linux }
  {$FATAL Die Unit XPLINUX kann nur unter Linux compiliert werden }
{$ENDIF }

interface

uses xpglobal;

function StrDostoLinux(const InStr : String): String;
procedure InitNCurses;
procedure DoneNCurses;

implementation
uses
  ncurses;

function StrDostoLinux(const InStr : String): String;
const
   MaxConvChars					       = 7;
   dos2lin	: array [0..1] of String[MaxConvChars] =
       ('᎙',
	'');
var
   I, CI : Integer;
   Res	 : String;
begin
   Res := InStr;
   for I := 1 to length(InStr) do
   begin
      for CI := 1 to MaxConvChars do
	 if Res[I] = dos2lin[0][CI] then Res[I] := dos2lin[1][CI];
   end;
   StrDostoLinux := Res;
end;

procedure InitNCurses;
begin
  if initscr=Nil then halt(1);
  start_color;
//  init_pair(1,COLOR_WHITE,COLOR_BLUE);
//  wbkgd(win, COLOR_PAIR(1));
  erase;
  refresh;
//  box(win, ACS_VLINE, ACS_HLINE);
//  wrefresh(win);
//  mvwaddstr(win,1,1,'Press any key to continue !');
//  wrefresh(win);
//  raw;
//  wgetch(win);
end;

procedure DoneNCurses;
begin
   endwin;
end;
   
begin
   InitNCurses;
end.
