{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 2000 OpenXP Team & Markus Kmmerer, http://www.openxp.de    }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Compilerdirektiven fr CrossPoint (OpenXP)                      }

{ Wenn gesetzt, werden erweiterte Checks in der EXE-Datei durchgefhrt
  (Rangecheck) usw. }

{.$DEFINE Debug }

{ Wenn gesetzt, werden in die TPU/TPP Debug Informationen gespeichert
  und es kann eine ausfhrliche Map-Datei erstellt werden. ndert den
  Code der EXE-Datei nicht }

{$DEFINE DebugInfo }

{ Keine Assembler-Routine verwenden. Ein Gegenpart in Pascal mu
  existieren }
{.$DEFINE NOASM }

{ Ist definiert, wenn Beta-Informationen anzeigt werden sollen }
{$DEFINE Beta }

{ Wenn dieser Schalter nicht gesetzt ist, bentigt XP eine 386er mit
  CoProzessor, ansonsten ist es auch auf XT aufwrts lauffhig }
{.$DEFINE NO386 }

{ Wenn dieser Schalter definiert ist, wird eine Version mit CAPI-
  Unterstzung compiliert }
{.$DEFINE CAPI }

{ --- ab hier sind keine nderungen ntig --- }

{$IFDEF VER70 }
  {$DEFINE BP }   { 16 Bit Borland Pascal 7 oder 8 (Delphi 1) }
  {$IFDEF DPMI }
    {$DEFINE DPMI16 }
  {$ENDIF }
{$ENDIF }

{$IFDEF VER80 }
  {$DEFINE BP }   { 16 Bit Borland Pascal 7 oder 8 (Delphi 1) }
  {$IFDEF DPMI }
    {$DEFINE DPMI16 }
  {$ENDIF }
{$ENDIF }

{$IFDEF BP } { Nur fr Borland Pascal 7 und 8 }
  {$A+,B-,D-,E-,F-,I-,G+,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
  {$IFDEF NO386 }
    {$G-,E+,N+} { keine 286er Befehle, kein CoPro ntig }
  {$ENDIF }
{$ENDIF }

{$IFDEF VER130 }      { Delphi 5 }
  {$DEFINE Ver32 }
  {$DEFINE Win32 }
  {$DEFINE Delphi }
  {$A+,B-,C-,D+,E-,F-,G+,H-,I-,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U+,V-,W-,X+,Y-,Z1}
{$ENDIF }

{$IFDEF __CON__ } { Nur fr TMT Pascal >= 3.30 }
  {$DEFINE VER32 }
  {$DEFINE TMT }
  {$DEFINE DOS32 }
  {$A+,B-,D-,F-,I-,L-,O-,P-,Q-,R-,S-,T-,V-,X+}
{$ENDIF }

{$IFDEF VirtualPascal }  { Virtual Pascal ab 2.0 }
  {$DEFINE VP }
  {$DEFINE Ver32 }
  {$B-,H-,I-,J+,P+,Q-,R-,T-,V-,W-,X+,Z-}
  {&AlignCode+,AlignData+,AlignRec-,Asm-,Cdecl-,Delphi-,Frame+,G3+,LocInfo-}
  {&Open32-,Optimise+,OrgName-,SmartLink+,Speed+,ZD-}
{$ENDIF }

{$IFDEF FPC }             { Freepascal >= 0.99.14 }
  {$DEFINE Ver32 }
  {$IFDEF GO32V2 }
    {$DEFINE DOS32 }
  {$ENDIF }
  {$C-,H-,I-,M-,P-,T-,V-,X+}
  {$MODE TP }
  {$ASMMODE Intel }
  {$GOTO ON }
{$ENDIF }

{$IFDEF DebugInfo }
  {$IFDEF BP } { Nur fr Borland Pascal 7 }
    {$D+,L+,Y+}
  {$ENDIF }
  {$IFDEF VirtualPascal }
    {$D+,LocInfo+}
  {$ENDIF }
{$ENDIF }

{$IFDEF Debug }
  {$IFDEF BP } { Nur fr Borland Pascal 7 }
    {$R+,S+,Q+}
  {$ENDIF }
  {$IFDEF VirtualPascal }
    {$R+,S+,Q+,W+,Optimize-}
  {$ENDIF }
{$ENDIF }

{$IFDEF Ver32 }
  {$IFDEF CAPI } { Umgeht hssliche Warnings in TMT Pascal }
    {$UNDEF CAPI } { Bis jetzt keine CAPI-Untersttzung in 32 Bit Versionen }
  {$ENDIF CAPI }
{$ENDIF }

